
/*
 *  PHEX - The pure-java Gnutella-servant.
 *  Copyright (C) 2000 William W. Wong
 *  williamw@jps.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package phex.actions.config;


import java.awt.event.*;
import java.util.*;
import java.net.*;
import javax.swing.*;

import phex.*;
import phex.actions.base.*;
import phex.config.*;
import phex.dialogues.*;


public class ActionConfigDownload extends ActionBase
{

	public ActionConfigDownload(BaseFrame frame, String label, Icon icon)
	{
		super(frame, label, icon);
	}


	public void actionPerformed( ActionEvent event )
	{
		DlgConfigDownload	dlg = new DlgConfigDownload(
			mFrame,
			ServiceManager.sCfg.mDownloadDir,
			ServiceManager.sCfg.mDownloadMaxBandwidth / 1024,
			ServiceManager.sCfg.mMaxDownload,
			ServiceManager.sCfg.mMaxDownloadPerIP,
			ServiceManager.sCfg.mDownloadAutoRemoveCompleted);

		dlg.setVisible(true);
		dlg.dispose();

		if (!dlg.getCancel())
		{
			ServiceManager.sCfg.mDownloadDir = dlg.getPath();
			ServiceManager.sCfg.mDownloadMaxBandwidth = dlg.getBandwidth() * 1024;
			ServiceManager.sCfg.mMaxDownload = dlg.getLimit();
			ServiceManager.sCfg.mMaxDownloadPerIP = dlg.getLimitPerIP();
			ServiceManager.sCfg.mDownloadAutoRemoveCompleted = dlg.getRemoveCompleted();
			ServiceManager.sCfg.save();

			ServiceManager.getDownloadManager().createEnoughWorkers();
		}
	}


	public void refresh()
	{
		setEnabled(true);
	}
}


