
/*
 *  PHEX - The pure-java Gnutella-servant.
 *  Copyright (C) 2000 William W. Wong
 *  williamw@jps.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package phex.actions.config;


import java.awt.event.*;
import java.util.*;
import java.net.*;
import javax.swing.*;

import phex.*;
import phex.actions.base.*;
import phex.config.*;
import phex.dialogues.*;


public class ActionConfigNet extends ActionBase
{
	public ActionConfigNet(BaseFrame frame, String label, Icon icon)
	{
		super(frame, label, icon);
	}


	public void actionPerformed( ActionEvent event )
	{
		int				oldPort = ServiceManager.sCfg.mListeningPort;

		DlgConfigNet	dlg = new DlgConfigNet(mFrame);

		dlg.setVisible(true);
		dlg.dispose();

		if (!dlg.getCancel())
		{
			ServiceManager.getListener().setMyIP(ServiceManager.sCfg.mMyIP);
			if (ServiceManager.sCfg.mListeningPort != oldPort)
			{
				ServiceManager.getListener().shutdown(true);
				try
				{
					ServiceManager.getListener().startup();
				}
				catch (Exception e)
				{
					JOptionPane.showMessageDialog(mFrame,
						"Fail to start listener after changed listen port.  " + e,
						"Listener Failed",
						JOptionPane.ERROR_MESSAGE);
				}
			}

			ServiceManager.getManager().getMainFrame().setTitle();
		}
	}


	public void refresh()
	{
		setEnabled(true);
	}
}


