
/*
 *  PHEX - The pure-java Gnutella-servant.
 *  Copyright (C) 2000 William W. Wong
 *  williamw@jps.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package phex.actions.config;


import java.awt.event.*;
import java.util.*;
import java.net.*;
import javax.swing.*;

import phex.*;
import phex.actions.base.*;
import phex.config.*;
import phex.dialogues.*;


public class ActionConfigUpload extends ActionBase
{

	public ActionConfigUpload(BaseFrame frame, String label, Icon icon)
	{
		super(frame, label, icon);
	}


	public void actionPerformed( ActionEvent event )
	{
		String	updir = ServiceManager.sCfg.mUploadDir;
		String	orgExc = ServiceManager.sCfg.mUploadFileExclusions;
		String	orgInc = ServiceManager.sCfg.mUploadFileInclusions;
		boolean	orgRecursive = ServiceManager.sCfg.mUploadScanRecursively;
		
		DlgConfigUpload	dlg = new DlgConfigUpload(
			mFrame,
			ServiceManager.sCfg.mUploadDir,
			ServiceManager.sCfg.mUploadMaxBandwidth / 1024,
			ServiceManager.sCfg.mMaxUpload,
			ServiceManager.sCfg.mMaxUploadPerIP,
			ServiceManager.sCfg.mUploadMaxSearch,
			ServiceManager.sCfg.mUploadAutoRemoveCompleted,
			ServiceManager.sCfg.mUploadFileExclusions,
			ServiceManager.sCfg.mUploadFileInclusions,
			ServiceManager.sCfg.mUploadScanRecursively,
			ServiceManager.sCfg.mShareBrowseDir);

		dlg.setVisible(true);
		dlg.dispose();

		if (!dlg.getCancel())
		{
			ServiceManager.sCfg.mUploadDir = dlg.getPath();
			ServiceManager.sCfg.mUploadMaxBandwidth = dlg.getBandwidth() * 1024;
			ServiceManager.sCfg.mMaxUpload = dlg.getLimit();
			ServiceManager.sCfg.mMaxUploadPerIP = dlg.getLimitPerIP();
			ServiceManager.sCfg.mUploadMaxSearch = dlg.getSearchLimit();
			ServiceManager.sCfg.mUploadAutoRemoveCompleted = dlg.getRemoveCompleted();
			ServiceManager.sCfg.mUploadFileExclusions = dlg.getExclusion();
			ServiceManager.sCfg.mUploadFileInclusions = dlg.getInclusion();
			ServiceManager.sCfg.mUploadScanRecursively = dlg.getScanRecursively();
			ServiceManager.sCfg.mShareBrowseDir = dlg.getShareBrowseDir();
			ServiceManager.sCfg.save();

			if (!updir.equals(ServiceManager.sCfg.mUploadDir) ||
				!orgExc.equals(ServiceManager.sCfg.mUploadFileExclusions) ||
				!orgInc.equals(ServiceManager.sCfg.mUploadFileInclusions) ||
				orgRecursive != ServiceManager.sCfg.mUploadScanRecursively)
			{
				ServiceManager.getShareManager().rescan();
			}
			
		}
	}


	public void refresh()
	{
		setEnabled(true);
	}
}


