
/*
 *  PHEX - The pure-java Gnutella-servant.
 *  Copyright (C) 2000 William W. Wong
 *  williamw@jps.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package phex.actions.base;


import java.awt.event.*;
import java.util.*;
import java.net.*;
import javax.swing.*;

import phex.*;
import phex.actions.base.*;
import phex.download.*;
import phex.host.*;


public class ActionFileExit extends ActionBase
{

	public ActionFileExit(BaseFrame frame, String label, Icon icon)
	{
		super(frame, label, icon);
	}


	public void actionPerformed( ActionEvent event )
	{
		DownloadManager		dm = ServiceManager.getDownloadManager();
		ShareManager		sm = ServiceManager.getShareManager();
		HostManager			hm = ServiceManager.getHostManager();

		if (dm.getDownloadingCount() > 0 || sm.getUploadingCount() > 0)
		{
			int	option = JOptionPane.showConfirmDialog(
				mFrame, 
				"There are files being downloaded or uploaded.  Exit anyway?",
				"Confirmation",
				JOptionPane.YES_NO_CANCEL_OPTION,
				JOptionPane.INFORMATION_MESSAGE);

			if (option != JOptionPane.YES_OPTION)
			{
				// Don't proceed.
				return;
			}
		}

		try
		{
			hm.removeStartHosts();
			hm.saveHosts();
			dm.saveDownloadInfo();
		}
		catch(Exception e)
		{
			// ignore.
		}

		mFrame.dispose();
        System.exit(0);
	}


	public void refresh()
	{
		setEnabled(true);
	}
}


