
/*
 *  PHEX - The pure-java Gnutella-servant.
 *  Copyright (C) 2000 William W. Wong
 *  williamw@jps.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package phex.actions.view;


import java.awt.event.*;
import javax.swing.*;

import phex.*;
import phex.actions.base.*;


/**
*	The ActionViewCrossPlatformLF class performs the operation of changing
*	the Look and Feel of the program to CrossPlatform Look and Feel.
*/
public class ActionViewCrossPlatformLF extends ActionBase
{
	public ActionViewCrossPlatformLF(BaseFrame frame, String label, Icon icon)
	{
		super(frame, label, icon);
	}


	public void actionPerformed(ActionEvent event)
	{
		ServiceManager.sCfg.mLFClassName = UIManager.getCrossPlatformLookAndFeelClassName();
		ServiceManager.sCfg.save();
		BaseFrame.resetAllFramesLookAndFeel();
	}


	public void refresh()
	{
		String	curr = ServiceManager.sCfg.mLFClassName;
		boolean	flag = curr.equals(UIManager.getCrossPlatformLookAndFeelClassName());

		for (int i = 0; i < mRefreshComponents.size(); i++)
		{
			AbstractButton	comp = (AbstractButton)mRefreshComponents.elementAt(i);
			comp.setSelected(flag);
		}
		setEnabled(true);
	}
}


