
/*
 *  PHEX - The pure-java Gnutella-servant.
 *  Copyright (C) 2000 William W. Wong
 *  williamw@jps.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package phex;


import java.util.*;

import phex.interfaces.*;

public class DataChanger
{
	private Vector		mListeners = new Vector();


	public void addListener(IDataChangedListener listener)
	{
		mListeners.addElement(listener);
	}


	public void removeListener(IDataChangedListener listener)
	{
		mListeners.removeElement(listener);
	}


	public void dataChanged(Object source)
	{
		for (int i = 0; i < mListeners.size(); i++)
		{
			((IDataChangedListener)mListeners.elementAt(i)).dataChanged(source);
		}
	}

}


