
/*
 *  PHEX - The pure-java Gnutella-servant.
 *  Copyright (C) 2000 William W. Wong
 *  williamw@jps.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package phex.host;

import phex.*;
import phex.cqueue.*;
import phex.interfaces.*;


public class HostMsg implements CQueueEntry
{
	private Host		mHost = null;
	private IMsg		mMsg = null;
	private boolean		mUrgent = false;



	public HostMsg()
	{
	}


	public void setHost(Host host)
	{
		mHost = host;
	}


	public Host getHost()
	{
		return mHost;
	}


	public void setMsg(IMsg msg)
	{
		mMsg = msg;
	}


	public IMsg getMsg()
	{
		return mMsg;
	}


	public void setUrgent(boolean urgent)
	{
		mUrgent = urgent;
	}


	public boolean getUrgent()
	{
		return mUrgent;
	}


	public String toString()
	{
		return mHost + " " + mMsg;
	}

	


	private	CQueueEntry	mNext = null;
	private CQueueEntry	mPrev = null;
	private CQueue		mQueue = null;

	public CQueueEntry getPrev()
	{
		return mPrev;
	}

	public void setPrev(CQueueEntry prev)
	{
		mPrev = prev;
	}

	public CQueueEntry getNext()
	{
		return mNext;
	}

	public void setNext(CQueueEntry next)
	{
		mNext = next;
	}

	public void setCQueue(CQueue queue)
	{
		mQueue = queue;
	}

	public CQueue getCQueue()
	{
		return mQueue;
	}
}



