
/*
 *  PHEX - The pure-java Gnutella-servant.
 *  Copyright (C) 2000 William W. Wong
 *  williamw@jps.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package phex.msg;

import phex.*;
import phex.interfaces.*;


public class MsgInit implements IMsg
{
	private MsgHeader	mHeader;


	public MsgInit()
	{
		MsgHeader	header = new MsgHeader();
		setHeader(header);
	}


	public MsgInit(MsgHeader header)
	{
		setHeader(header);
	}


	public void setHeader(MsgHeader header)
	{
		mHeader = header;
		mHeader.setFunction(MsgHeader.sInit);
		mHeader.setDataLen(0);
	}


	public MsgHeader getHeader()
	{
		return mHeader;
	}




	public void computeHeaderLen()
	{
		mHeader.setDataLen(getSize() - mHeader.getSize());
	}

	
	public int getSize()
	{
		return mHeader.getSize();
	}


	public void copy(MsgInit b)
	{
		mHeader.copy(b.getHeader());
	}


	public int serialize(byte[] outbuf, int offset)
			throws Exception
	{
		return mHeader.serialize(outbuf, offset);
	}


	public int deserialize(byte[] inbuf, int offset)
			throws Exception
	{
		// Already read the header.  Nothing else to read.
		return offset;
	}


	public String toString()
	{
		return	"[" +
				mHeader +
				"]";
	}
}

