
/*
 *  PHEX - The pure-java Gnutella-servant.
 *  Copyright (C) 2000 William W. Wong
 *  williamw@jps.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package phex;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;


//
// Jumping through hoop to get around this stupid alt-key in textfield bug in JDK 1.2.
//
public class TextFieldFactory
{
	public static JTextField newTextField(String str, int columns)
	{
		JTextField	text = null;

		if (isVersion11())
		{
			text = new JTextField();
		}
		else
		{
			try
			{
				text = (JTextField)Class.forName("phex.TextFieldFix").newInstance();
			}
			catch (Exception e)
			{
				System.out.println(e);
			}
		}

		text.setText(str);
		text.setColumns(columns);

		return text;
	}


	private static boolean isVersion11()
	{
		String	vers = System.getProperty("java.version");
		if (vers.compareTo("1.2") < 0)
		{
			return true;
		}
		return false;
	}

}

